Priority: Normal
Assignee:

Target version: 2.7
Description

Current master always warn pattern matching syntax.
It discourage users try them.

Another noisy warnings can stop by Warning[:deprecated]=false.

So | think the future may be more useful if Warning[:experimentall=false or Warning[:pattern_matching]=false can stop warnings.

Associated revisions

Revision 07e595fdbd75ed44473073cdf8cd758572d11709 - 12/20/2019 02:48 PM - nobu (Nobuyoshi Nakada)

Added experimental warning category
Revision 07e595fdbd75ed44473073cdf8cd758572d11709 - 12/20/2019 02:48 PM - nobu (Nobuyoshi Nakada)
Added experimental warning category
Revision 07e595fd - 12/20/2019 02:48 PM - nobu (Nobuyoshi Nakada)

Added experimental warning category
Revision 484c1be8956b7bb7a0253c6d6¢c7a740c341487fa - 12/20/2019 02:51 PM - nobu (Nobuyoshi Nakada)
Added -W:experimental command line option
Revision 484c1be8956b7bb7a0253c6d6¢c7a740c341487fa - 12/20/2019 02:51 PM - nobu (Nobuyoshi Nakada)
Added -W:experimental command line option
Revision 484c1be8 - 12/20/2019 02:51 PM - nobu (Nobuyoshi Nakada)

Added -W:experimental command line option

[Feature #16420]

Revision 3739ddc36f462b794ec05c0cfc36458a8d1e17a7 - 12/24/2019 03:11 AM - nobu (Nobuyoshi Nakada)
Added -W:experimental to --help [Feature #16420]

Revision 3739ddc36f462b794ec05c0cfc36458a8d1e17a7 - 12/24/2019 03:11 AM - nobu (Nobuyoshi Nakada)
Added -W:experimental to --help [Feature #16420]

Revision 3739ddc3 - 12/24/2019 03:11 AM - nobu (Nobuyoshi Nakada)
Added -W:experimental to --help [Feature #16420]

History

#1 - 12/14/2019 04:06 PM - shevegen (Robert A. Heiler)
Although | can not say whether the specific API proposed here is useful or not (matz may just
have to decide on the API for general use), | agree with the statement of controlling/toggling
the "noise" level, based on different needs by the ruby user - some prefer warnings, which is
fine, whereas others may prefer less warnings (or just suppress some warnings specifically
while allowing others to show up).

| do not have an alternative API proposal, but the suggestions here make sense to me.

| think :deprecated and :pattern_matching is simple to understand; for :experimental, it may
have to be defined clearly what exactly is to be considered experimental and what is not, since
this may change between ruby versions.

Perhaps there should be some way to query from ruby which specific features are experimental
or not, e. g. an Array of symbols or something like that. That way the ruby user can make
conditional checks and enable/disable certain features selectively (or not), or rather the
warnings for such experimental features, on a per gem/project basis too - but | digress.

In short | think the suggestion by znz makes sense.

#2 - 12/20/2019 05:41 AM - naruse (Yui NARUSE)

- Target version setto 2.7

#3 - 12/20/2019 03:07 PM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset git|07e595fdbd75ed44473073cdf8cd758572d11709.

Added experimental warning category

[Feature #16420]

#4 - 12/21/2019 02:09 PM - nobu (Nobuyoshi Nakada)

Changing the flag at runtime causes problems, mainly editors' syntax highlighting, ruby -c etc.
How about a new "magic comment" pragma?

# —-*- experimental-syntax: true —*-

or, more strictly

# —*- experimental-syntax: pattern-matching —*-

06/20/2025 22


https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/07e595fdbd75ed44473073cdf8cd758572d11709
https://redmine.ruby-lang.org/issues/16420
http://www.tcpdf.org

